QXmpp: QXmppConfiguration Class Reference

QXmpp Version:0.7.5

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Functions Variables Enumerations Enumerator Properties Groups
Public Types | Public Member Functions | List of all members
QXmppConfiguration Class Reference

The QXmppConfiguration class holds configuration options. More...

`#include <QXmppConfiguration.h>`

## Public Types
enum | StreamSecurityMode { TLSEnabled = 0, TLSDisabled, TLSRequired }
enum | NonSASLAuthMechanism { NonSASLPlain = 0, NonSASLDigest }

## Public Member Functions
| QXmppConfiguration ()
| Creates a QXmppConfiguration object.
| QXmppConfiguration (const QXmppConfiguration &other)
| Creates a copy of other.
| ~QXmppConfiguration ()
QXmppConfiguration & | operator= (const QXmppConfiguration &other)
| Assigns other to this QXmppConfiguration.
QString | host () const
void | setHost (const QString &)
QString | domain () const
void | setDomain (const QString &)
int | port () const
void | setPort (int)
QString | user () const
void | setUser (const QString &)
QString | password () const
void | setPassword (const QString &)
QString | resource () const
void | setResource (const QString &)
QString | jid () const
void | setJid (const QString &jid)
QString | jidBare () const
QString | facebookAccessToken () const
| Returns the access token used for X-FACEBOOK-PLATFORM authentication.
void | setFacebookAccessToken (const QString &)
QString | facebookAppId () const
| Returns the application ID used for X-FACEBOOK-PLATFORM authentication.
void | setFacebookAppId (const QString &)
QString | googleAccessToken () const
| Returns the access token used for X-OAUTH2 authentication.
void | setGoogleAccessToken (const QString &accessToken)
QString | windowsLiveAccessToken () const
| Returns the access token used for X-MESSENGER-OAUTH2 authentication.
void | setWindowsLiveAccessToken (const QString &accessToken)
bool | autoAcceptSubscriptions () const
void | setAutoAcceptSubscriptions (bool)
bool | autoReconnectionEnabled () const
void | setAutoReconnectionEnabled (bool)
bool | useSASLAuthentication () const
| Returns whether to make use of SASL authentication.
void | setUseSASLAuthentication (bool)
| Sets whether to make use of SASL authentication.
bool | useNonSASLAuthentication () const
| Returns whether to make use of non-SASL authentication.
void | setUseNonSASLAuthentication (bool)
| Sets whether to make use of non-SASL authentication.
bool | ignoreSslErrors () const
void | setIgnoreSslErrors (bool)
QXmppConfiguration::StreamSecurityMode | streamSecurityMode () const
void | setStreamSecurityMode (QXmppConfiguration::StreamSecurityMode mode)
QXmppConfiguration::NonSASLAuthMechanism | nonSASLAuthMechanism () const
void | setNonSASLAuthMechanism (QXmppConfiguration::NonSASLAuthMechanism)
QString | saslAuthMechanism () const
void | setSaslAuthMechanism (const QString &mechanism)
QNetworkProxy | networkProxy () const
void | setNetworkProxy (const QNetworkProxy &proxy)
int | keepAliveInterval () const
void | setKeepAliveInterval (int secs)
int | keepAliveTimeout () const
void | setKeepAliveTimeout (int secs)
QList< QSslCertificate > | caCertificates () const
| Returns the a list of trusted CA certificates.
void | setCaCertificates (const QList< QSslCertificate > &)
| Specifies a list of trusted CA certificates.

## Detailed Description

The QXmppConfiguration class holds configuration options.

It can be passed to QXmppClient to specify the options when connecting to an XMPP server.

It is a container of all the settings, configuration required for connecting to an XMPP server. E.g. server name, username, port, type of authentication mechanism, type of security used by stream (encryption), etc..

## Member Enumeration Documentation

enum QXmppConfiguration::NonSASLAuthMechanism

An enumeration for various Non-SASL authentication mechanisms available. The server may or may not allow QXmppConfiguration::Plain mechanism. So specifying the mechanism is just a hint to the library.

Enumerator:

  NonSASLPlain | Plain.
  NonSASLDigest | Digest (default)

enum QXmppConfiguration::StreamSecurityMode

An enumeration for type of the Security Mode that is stream is encrypted or not. The server may or may not have TLS feature. Server may force the encryption. Depending upon all this user can specify following options.

Enumerator:

  TLSEnabled | Encryption is used if available (default)
  TLSDisabled | No encryption is server allows.
  TLSRequired | Encryption is a must otherwise connection would not be established

## Constructor & Destructor Documentation

QXmppConfiguration::QXmppConfiguration | ( |  | ) |

Creates a QXmppConfiguration object.

An enumeration for various SASL authentication mechanisms available. The server may or may not allow any particular mechanism. So depending upon the availability of mechanisms on the server the library will choose a mechanism.

QXmppConfiguration::~QXmppConfiguration | ( |  | ) |

Destructor, destroys the QXmppConfiguration object.

## Member Function Documentation

bool QXmppConfiguration::autoAcceptSubscriptions | ( |  | ) | const

Returns the auto-accept-subscriptions-request configuration.

Returns
  boolean value true means that auto-accept-subscriptions-request is enabled else disabled for false

bool QXmppConfiguration::autoReconnectionEnabled | ( |  | ) | const

Returns the auto-reconnect-on-disconnection-on-error configuration.

Returns
  boolean value true means that auto-reconnect is enabled else disabled for false

QString QXmppConfiguration::domain | ( |  | ) | const

Returns the domain name.

Returns
  domain name

QString QXmppConfiguration::host | ( |  | ) | const

Returns the host name.

Returns
  host name

bool QXmppConfiguration::ignoreSslErrors | ( |  | ) | const

Returns whether SSL errors (such as certificate validation errors) are to be ignored when connecting to the XMPP server.

QString QXmppConfiguration::jid | ( |  | ) | const

Returns the jabber id (jid).

Returns
  jabber id (jid) (e.g. "qxmpp.test1@gmail.com/resource" or qxmpp.nosp@m.test.nosp@m.@jabb.nosp@m.er.o.nosp@m.rg/QXmpp156)

QString QXmppConfiguration::jidBare | ( |  | ) | const

Returns the bare jabber id (jid), without the resource identifier.

Returns
  bare jabber id (jid) (e.g. "qxmpp.test1@gmail.com" or qxmpp.nosp@m.test.nosp@m.@jabb.nosp@m.er.o.nosp@m.rg)

int QXmppConfiguration::keepAliveInterval | ( |  | ) | const

Returns the keep alive interval in seconds.

The default value is 60 seconds.

int QXmppConfiguration::keepAliveTimeout | ( |  | ) | const

Returns the keep alive timeout in seconds.

The default value is 20 seconds.

QNetworkProxy QXmppConfiguration::networkProxy | ( |  | ) | const

Returns the specified network proxy. The default value is QNetworkProxy::DefaultProxy that is the proxy is determined based on the application proxy set using QNetworkProxy::setApplicationProxy().

Returns
  QNetworkProxy

QXmppConfiguration::NonSASLAuthMechanism QXmppConfiguration::nonSASLAuthMechanism | ( |  | ) | const

Returns the Non-SASL authentication mechanism configuration.

Returns
  QXmppConfiguration::NonSASLAuthMechanism

QString QXmppConfiguration::password | ( |  | ) | const

Returns the password.

Returns
  password

int QXmppConfiguration::port | ( |  | ) | const

Returns the port number.

Returns
  port number

QString QXmppConfiguration::resource | ( |  | ) | const

Returns the resource identifier.

Returns
  resource identifier

QString QXmppConfiguration::saslAuthMechanism | ( |  | ) | const

Returns the preferred SASL authentication mechanism.

Default value: "DIGEST-MD5"

void QXmppConfiguration::setAutoAcceptSubscriptions | ( | bool | value | ) |

Sets the auto-accept-subscriptions-request configuration.

Parameters

  value | boolean value true means that auto-accept-subscriptions-request is enabled else disabled for false

void QXmppConfiguration::setAutoReconnectionEnabled | ( | bool | value | ) |

Sets the auto-reconnect-on-disconnection-on-error configuration.

Parameters

  value | boolean value true means that auto-reconnect is enabled else disabled for false

void QXmppConfiguration::setDomain | ( | const QString & | domain | ) |

Sets the domain name.

Parameters

  domain | Domain name e.g. "gmail.com" and "jabber.org".

Note
  host name and domain name can be different for google domain name is gmail.com and host name is talk.google.com

void QXmppConfiguration::setFacebookAccessToken | ( | const QString & | accessToken | ) |

Sets the access token used for X-FACEBOOK-PLATFORM authentication.

This token is returned by Facebook at the end of the OAuth authentication process.

Parameters

  accessToken |

void QXmppConfiguration::setFacebookAppId | ( | const QString & | appId | ) |

Sets the application ID used for X-FACEBOOK-PLATFORM authentication.

Parameters

  appId |

void QXmppConfiguration::setGoogleAccessToken | ( | const QString & | accessToken | ) |

Sets the access token used for X-OAUTH2 authentication.

This token is returned by Google at the end of the OAuth authentication process.

Parameters

  accessToken |

void QXmppConfiguration::setHost | ( | const QString & | host | ) |

Sets the host name.

Parameters

  host | host name of the XMPP server where connection has to be made (e.g. "jabber.org" and "talk.google.com"). It can also be an IP address in the form of a string (e.g. "192.168.1.25").

void QXmppConfiguration::setIgnoreSslErrors | ( | bool | value | ) |

Specifies whether SSL errors (such as certificate validation errors) are to be ignored when connecting to an XMPP server.

void QXmppConfiguration::setJid | ( | const QString & | jid | ) |

Sets the JID. If a full JID (i.e. one with a resource) is given, calling this method will update the username, domain and resource. Otherwise, only the username and the domain will be updated.

Parameters

  jid |

void QXmppConfiguration::setKeepAliveInterval | ( | int | secs | ) |

Specifies the interval in seconds at which keep alive (ping) packets will be sent to the server.

If set to zero, no keep alive packets will be sent.

The default value is 60 seconds.

void QXmppConfiguration::setKeepAliveTimeout | ( | int | secs | ) |

Specifies the maximum time in seconds to wait for a keep alive response from the server before considering we are disconnected.

If set to zero or a value larger than the keep alive interval, no timeout will occur.

The default value is 20 seconds.

void QXmppConfiguration::setNetworkProxy | ( | const QNetworkProxy & | proxy | ) |

Specifies the network proxy used for the connection made by QXmppClient. The default value is QNetworkProxy::DefaultProxy that is the proxy is determined based on the application proxy set using QNetworkProxy::setApplicationProxy().

Parameters

  proxy | QNetworkProxy

void QXmppConfiguration::setNonSASLAuthMechanism | ( | QXmppConfiguration::NonSASLAuthMechanism | mech | ) |

Hints the library the Non-SASL authentication mechanism to be used for authentication.

Parameters

  mech | QXmppConfiguration::NonSASLAuthMechanism

void QXmppConfiguration::setPassword | ( | const QString & | password | ) |

Sets the password.

Parameters

  password | Password for the specified username

void QXmppConfiguration::setPort | ( | int | port | ) |

Sets the port number.

Parameters

  port | Port number at which the XMPP server is listening. The default value is 5222.

void QXmppConfiguration::setResource | ( | const QString & | resource | ) |

Sets the resource identifier.

Multiple resources (e.g., devices or locations) may connect simultaneously to a server on behalf of each authorized client, with each resource differentiated by the resource identifier of an XMPP address (e.g. node@domain/home vs. node@domain/work)

The default value is "QXmpp".

Parameters

  resource | Resource identifier of the client in connection.

void QXmppConfiguration::setSaslAuthMechanism | ( | const QString & | mechanism | ) |

Sets the preferred SASL authentication mechanism.

Valid values: "PLAIN", "DIGEST-MD5", "ANONYMOUS", "X-FACEBOOK-PLATFORM"

void QXmppConfiguration::setStreamSecurityMode | ( | QXmppConfiguration::StreamSecurityMode | mode | ) |

Specifies the specified security mode for the stream. The default value is QXmppConfiguration::TLSEnabled.

Parameters

  mode | StreamSecurityMode

void QXmppConfiguration::setUser | ( | const QString & | user | ) |

Sets the username.

Parameters

  user | Username of the account at the specified XMPP server. It should be the name without the domain name. E.g. "qxmpp.test1" and not "qxmpp.test1@gmail.com"

void QXmppConfiguration::setWindowsLiveAccessToken | ( | const QString & | accessToken | ) |

Sets the access token used for X-MESSENGER-OAUTH2 authentication.

This token is returned by Windows Live at the end of the OAuth authentication process.

Parameters

  accessToken |

QXmppConfiguration::StreamSecurityMode QXmppConfiguration::streamSecurityMode | ( |  | ) | const

Returns the specified security mode for the stream. The default value is QXmppConfiguration::TLSEnabled.

Returns
  StreamSecurityMode

QString QXmppConfiguration::user | ( |  | ) | const

Returns the username.

Returns
  username

The documentation for this class was generated from the following files:

- QXmppConfiguration.h
- QXmppConfiguration.cpp